package cn.efunbox.manage.base.entity;

import cn.efunbox.manage.base.enums.BaseStatusEnum;
import cn.efunbox.manage.base.enums.CompanyTypeEnum;
import cn.efunbox.manage.base.enums.IncomeStatusEnum;
import cn.efunbox.manage.base.enums.ManageTypeEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * Manage
 * Created by wangys on 2019/03/07
 */
@Data
@ToString
@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "manage")
public class Manage implements Serializable {

    @Id
    private String id;

    @Column(name = "dept_id")
    private Long deptId;

    @Column(name = "product_id")
    private String productId;

    @Column(name = "project_id")
    private String projectId;

    @Column(name = "company_id")
    private String companyId;

    @Enumerated(EnumType.ORDINAL)
    private ManageTypeEnum type;

    @Column(name = "amount")
    private Double amount;

    @Enumerated(EnumType.ORDINAL)
    private IncomeStatusEnum incomeStatus;

    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status;

    @Column(name = "cost_type")
    private String costType;

    @Enumerated(EnumType.ORDINAL)
    private CompanyTypeEnum company_type;

    @Column(name = "remark")
    private String remark;

    @Column(name = "happen_time")
    private Date happenTime;

    @Column(name = "sort")
    private Integer sort;

    @Column(name = "gmt_created")
    private Date gmtCreated;

    @Column(name = "gmt_modified")
    private Date gmtModified;

    @Transient
    private List<Long> deptIds;

    @Transient
    private List<String> costTypes;
}
