package cn.efunbox.manage.base.service.impl;

import cn.efunbox.manage.base.entity.Product;
import cn.efunbox.manage.base.enums.BaseStatusEnum;
import cn.efunbox.manage.base.repository.ProductRepository;
import cn.efunbox.manage.base.service.ProductService;
import cn.efunbox.manage.common.result.ApiCode;
import cn.efunbox.manage.common.result.ApiResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Objects;

/**
 * ProductServiceImpl
 * Created by wangys on 2019/03/07
 */
@Service
public class ProductServiceImpl implements ProductService {

    @Autowired
    ProductRepository productRepository;

    @Override
    public ApiResult list(Product product) {
        List<Product> products = productRepository.findByStatusOrderBySortDesc(BaseStatusEnum.NORMAL);
        if(Objects.nonNull(products)){
            return ApiResult.ok(products);
        }
        return ApiResult.error(ApiCode.UNKNOWN_ERROR);
    }

    @Override
    public ApiResult save(Product product) {
        product = productRepository.save(product);
        if(Objects.nonNull(product)){
            return ApiResult.ok(product);
        }
        return ApiResult.error(ApiCode.UNKNOWN_ERROR);
    }

    @Override
    public ApiResult update(Product product) {
        product = productRepository.update(product);
        if(Objects.nonNull(product)){
            return ApiResult.ok(product);
        }
        return ApiResult.error(ApiCode.UNKNOWN_ERROR);
    }
}
