package cn.efunbox.manage.base.service.impl;

import cn.efunbox.manage.base.entity.Project;
import cn.efunbox.manage.base.enums.BaseStatusEnum;
import cn.efunbox.manage.base.repository.ProjectRepository;
import cn.efunbox.manage.base.service.ProjectService;
import cn.efunbox.manage.common.result.ApiCode;
import cn.efunbox.manage.common.result.ApiResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Objects;

/**
 * ProjectServiceImpl
 * Created by wangys on 2019/03/08
 */
@Service
public class ProjectServiceImpl implements ProjectService {

    @Autowired
    ProjectRepository projectRepository;

    @Override
    public ApiResult list(Project project) {
        List<Project> projects = projectRepository.findByStatusOrderBySortDesc(BaseStatusEnum.NORMAL);
        if(Objects.nonNull(projects)){
            return ApiResult.ok(projects);
        }
        return ApiResult.error(ApiCode.UNKNOWN_ERROR);
    }

    @Override
    public ApiResult save(Project project) {
        project = projectRepository.save(project);
        if(Objects.nonNull(project)){
            return ApiResult.ok(project);
        }
        return ApiResult.error(ApiCode.UNKNOWN_ERROR);
    }

    @Override
    public ApiResult update(Project project) {
        project = projectRepository.update(project);
        if(Objects.nonNull(project)){
            return ApiResult.ok(project);
        }
        return ApiResult.error(ApiCode.UNKNOWN_ERROR);
    }
}
