package cn.efunbox.manage.common.utils;//package cn.efunbox.manage.common.utils;
//
//import com.alibaba.fastjson.JSON;
//import com.alibaba.fastjson.JSONObject;
//import org.apache.commons.httpclient.*;
//import org.apache.commons.httpclient.methods.GetMethod;
//import org.apache.commons.httpclient.methods.PostMethod;
//import org.apache.commons.httpclient.params.HttpMethodParams;
//import org.slf4j.Logger;
//import org.slf4j.LoggerFactory;
//import org.springframework.util.StringUtils;
//
//import javax.servlet.http.Cookie;
//import java.io.BufferedReader;
//import java.io.IOException;
//import java.io.InputStreamReader;
//import java.net.SocketTimeoutException;
//import java.net.URL;
//import java.net.URLConnection;
//import java.util.Iterator;
//import java.util.List;
//import java.util.Map;
//
///**
// * HttpClientUtil
// * Created by xusq on 2017/12/15.
// */
//public class HttpClientUtil {
//
//    private static final Logger logger = LoggerFactory.getLogger("HttpClientUtil");
//
//    public static JSONObject get(String url, Map params) {
//        String result = doRequest(url,params,Boolean.FALSE);
//
//        if (StringUtils.isEmpty(result)) {
//            return null;
//        }
//
//        return JSON.parseObject(result);
//    }
//
//    public static JSONObject getData(String url, Cookie[] cookies, Map params) {
//        String result = doRequestCookie(url,cookies,params,Boolean.FALSE);
//
//        if (StringUtils.isEmpty(result)) {
//            return null;
//        }
//
//        return JSON.parseObject(result);
//    }
//
//    public static JSONObject post(String url, Map params) {
//        String result = doRequest(url,params,Boolean.TRUE);
//
//        if (StringUtils.isEmpty(result)) {
//            return null;
//        }
//
//        return JSON.parseObject(result);
//    }
//
//    public static JSONObject postData(String url, Cookie[] cookies, Map params) {
//        String result = doRequestCookie(url,cookies,params,Boolean.TRUE);
//
//        if (StringUtils.isEmpty(result)) {
//            return null;
//        }
//
//        return JSON.parseObject(result);
//    }
//
//    private static String doRequest(String url, Map params, boolean isPost) {
//        logger.debug("HTTP调用[" + (isPost?"POST":"GET") + "][" + url + "][" + params + "]");
//
//        HttpClient client = new HttpClient();
//        HttpMethod httpMethod = null;
//
//        String result = "";
//        try {
//            if(isPost) {
//                httpMethod = new PostMethod(url);
//                if (params != null && params.size() > 0) {
//                    Iterator paramKeys = params.keySet().iterator();
//                    NameValuePair[] form = new NameValuePair[params.size()];
//                    int formIndex = 0;
//                    while(paramKeys.hasNext()) {
//                        String key = (String)paramKeys.next();
//                        Object value = params.get(key);
//                        if(value != null && value instanceof String && !value.equals("")) {
//                            form[formIndex] = new NameValuePair(key, (String)value);
//                            formIndex++;
//                        } else if(value != null && value instanceof String[] &&
//                                ((String[])value).length > 0) {
//                            NameValuePair[] tempForm =
//                                    new NameValuePair[form.length + ((String[])value).length - 1];
//                            for(int i=0; i<formIndex; i++) {
//                                tempForm[i] = form[i];
//                            }
//                            form = tempForm;
//                            for(String v : (String[])value) {
//                                form[formIndex] = new NameValuePair(key, (String)v);
//                                formIndex++;
//                            }
//                        }
//                    }
//                    ((PostMethod)httpMethod).setRequestBody(form);
//                }
//
//            } else {
//                if(params != null && params.size() > 0) {
//                    Iterator paramKeys = params.keySet().iterator();
//                    StringBuffer getUrl = new StringBuffer(url.trim());
//                    if(url.trim().indexOf("?") > -1) {
//                        if(url.trim().indexOf("?") < url.trim().length()-1 &&
//                                url.trim().indexOf("&")  < url.trim().length()-1) {
//                            getUrl.append("&");
//                        }
//                    } else {
//                        getUrl.append("?");
//                    }
//                    while(paramKeys.hasNext()) {
//                        String key = (String)paramKeys.next();
//                        Object value = params.get(key);
//                        if(value != null && value instanceof String && !value.equals("")) {
//                            getUrl.append(key).append("=").append(value).append("&");
//                        } else if(value != null && value instanceof String[] &&
//                                ((String[])value).length > 0) {
//                            for(String v : (String[])value) {
//                                getUrl.append(key).append("=").append(v).append("&");
//                            }
//                        }
//                    }
//                    if(getUrl.lastIndexOf("&") == getUrl.length()-1) {
//                        httpMethod = new GetMethod(getUrl.substring(0, getUrl.length()-1));
//                    } else {
//                        httpMethod = new GetMethod(getUrl.toString());
//                    }
//                } else {
//                    httpMethod = new GetMethod(url);
//                }
//            }
//
//            client.executeMethod(httpMethod);
//
//            result = httpMethod.getResponseBodyAsString();
//            logger.info(result);
//            BufferedReader manage = new BufferedReader(new InputStreamReader(
//                    httpMethod.getResponseBodyAsStream(),"ISO-8859-1"));
//            String line = null;
//            String html = null;
//            while((line = manage.readLine()) != null){
//                if(html == null) {
//                    html = "";
//                } else {
//                    html += "\r\n";
//                }
//                html += line;
//            }
//            if(html != null) {
//                result = new String(html.getBytes("ISO-8859-1"), "UTF-8");
//            }
//        } catch (SocketTimeoutException e) {
//            logger.error("连接超时[" + url + "]",e);
//        } catch (java.net.ConnectException e) {
//            logger.error("连接失败[" + url + "]",e);
//        } catch (Exception e) {
//            logger.error("连接时出现异常[" + url + "]",e);
//        } finally {
//            if (httpMethod != null) {
//                try {
//                    httpMethod.releaseConnection();
//                } catch (Exception e) {
//                    logger.error("释放网络连接失败[" + url + "]",e);
//                }
//            }
//        }
//
//        return result;
//    }
//
//    private static String doRequestCookie(String url, Cookie[] cookies, Map params, boolean isPost) {
//        logger.debug("HTTP调用[" + (isPost?"POST":"GET") + "][" + url + "][" + params + "]");
//
//        HttpClient client = new HttpClient();
//        HttpMethod httpMethod = null;
//
//        String result = "";
//        try {
//            if(isPost && params != null && params.size() > 0) {
//                Iterator paramKeys = params.keySet().iterator();
//                httpMethod = new PostMethod(url);
////                httpMethod.setRequestHeader("sign", "1");
////                httpMethod.setRequestHeader("uid", "1");
////                httpMethod.setRequestHeader("requestId", "1");
//                NameValuePair[] form = new NameValuePair[params.size()];
//                int formIndex = 0;
//                while(paramKeys.hasNext()) {
//                    String key = (String)paramKeys.next();
//                    Object value = params.get(key);
//                    if(value != null && value instanceof String && !value.equals("")) {
//                        form[formIndex] = new NameValuePair(key, (String)value);
//                        formIndex++;
//                    } else if(value != null && value instanceof String[] &&
//                            ((String[])value).length > 0) {
//                        NameValuePair[] tempForm =
//                                new NameValuePair[form.length + ((String[])value).length - 1];
//                        for(int i=0; i<formIndex; i++) {
//                            tempForm[i] = form[i];
//                        }
//                        form = tempForm;
//                        for(String v : (String[])value) {
//                            form[formIndex] = new NameValuePair(key, (String)v);
//                            formIndex++;
//                        }
//                    }
//                }
//                ((PostMethod)httpMethod).setRequestBody(form);
//            } else {
//                if(params != null && params.size() > 0) {
//                    Iterator paramKeys = params.keySet().iterator();
//                    StringBuffer getUrl = new StringBuffer(url.trim());
//                    if(url.trim().indexOf("?") > -1) {
//                        if(url.trim().indexOf("?") < url.trim().length()-1 &&
//                                url.trim().indexOf("&")  < url.trim().length()-1) {
//                            getUrl.append("&");
//                        }
//                    } else {
//                        getUrl.append("?");
//                    }
//                    while(paramKeys.hasNext()) {
//                        String key = (String)paramKeys.next();
//                        Object value = params.get(key);
//                        if(value != null && value instanceof String && !value.equals("")) {
//                            getUrl.append(key).append("=").append(value).append("&");
//                        } else if(value != null && value instanceof String[] &&
//                                ((String[])value).length > 0) {
//                            for(String v : (String[])value) {
//                                getUrl.append(key).append("=").append(v).append("&");
//                            }
//                        }
//                    }
//                    if(getUrl.lastIndexOf("&") == getUrl.length()-1) {
//                        httpMethod = new GetMethod(getUrl.substring(0, getUrl.length()-1));
//                    } else {
//                        httpMethod = new GetMethod(getUrl.toString());
//                    }
//                } else {
//                    httpMethod = new GetMethod(url);
//                }
//            }
//
////            httpMethod.releaseConnection();//这里最好把之前的资源放掉
////            cookies
//            for (Cookie cookie : cookies) {
//                if(cookie.getName().equals("uid")) {
//                    httpMethod.setRequestHeader(cookie.getName(), cookie.getValue());
////                    httpMethod.setRequestHeader(cookie.getName(), "e7e0d43a-36b1-4e71-a3a3-61469c90d0a2");
//                }
//                if(cookie.getName().equals("sign")) {
//                    httpMethod.setRequestHeader(cookie.getName(), cookie.getValue());
//                }
//                if(cookie.getName().equals("requestId")) {
//                    httpMethod.setRequestHeader(cookie.getName(), cookie.getValue());
//                }
//            }
//
//            client.executeMethod(httpMethod);
//
//            result = httpMethod.getResponseBodyAsString();
//            logger.info(result);
//            BufferedReader manage = new BufferedReader(new InputStreamReader(
//                    httpMethod.getResponseBodyAsStream(),"ISO-8859-1"));
//            String line = null;
//            String html = null;
//            while((line = manage.readLine()) != null){
//                if(html == null) {
//                    html = "";
//                } else {
//                    html += "\r\n";
//                }
//                html += line;
//            }
//            if(html != null) {
//                result = new String(html.getBytes("ISO-8859-1"), "UTF-8");
//            }
//        } catch (SocketTimeoutException e) {
//            logger.error("连接超时[" + url + "]",e);
//        } catch (java.net.ConnectException e) {
//            logger.error("连接失败[" + url + "]",e);
//        } catch (Exception e) {
//            logger.error("连接时出现异常[" + url + "]",e);
//        } finally {
//            if (httpMethod != null) {
//                try {
//                    httpMethod.releaseConnection();
//                } catch (Exception e) {
//                    logger.error("释放网络连接失败[" + url + "]",e);
//                }
//            }
//        }
//
//        return result;
//    }
//
//    /**
//     * post 发送json请求
//     *
//     * @param url
//     * @param jsonStr
//     * @return
//     */
//    @SuppressWarnings("deprecation")
//    public static byte[] postJsonRequest(String url, String jsonStr) {
//        PostMethod method = new PostMethod(url);
//        try {
//            HttpClient client = new HttpClient();
//            method.setRequestHeader("Content-type", "application/json; charset=UTF-8");
//            method.setRequestHeader("Accept", "application/json; charset=UTF-8");
//            // 设置为默认的重试策略
//            method.getParams().setParameter(HttpMethodParams.RETRY_HANDLER, new DefaultHttpMethodRetryHandler());
//
//            method.setRequestBody(jsonStr);
//            client.executeMethod(method);
//            return method.getResponseBody();
//        } catch (Exception e) {
//            e.printStackTrace();
//        } finally {
//            method.releaseConnection();
//        }
//        return null;
//    }
//
//    /**
//     * get请求
//     *
//     * @param url
//     * @return
//     * @throws IOException
//     * @throws HttpException
//     */
//    public static String getRequest(String url) {
//        String result = "";
//        BufferedReader in = null;
//        try {
//            String urlNameString = url;
//            URL realUrl = new URL(urlNameString);
//            // 打开和URL之间的连接
//            URLConnection connection = realUrl.openConnection();
//            // 设置通用的请求属性
//            connection.setRequestProperty("accept", "*/*");
//            connection.setRequestProperty("connection", "Keep-Alive");
//            connection.setRequestProperty("user-agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");
//            // 建立实际的连接
//            connection.connect();
//            // 获取所有响应头字段
//            Map<String, List<String>> map = connection.getHeaderFields();
//            // 遍历所有的响应头字段
//            for (String key : map.keySet()) {
//                System.out.println(key + "--->" + map.get(key));
//            }
//            // 定义 BufferedReader输入流来读取URL的响应
//            in = new BufferedReader(new InputStreamReader(connection.getInputStream()));
//            String line;
//            while ((line = in.readLine()) != null) {
//                result += line;
//            }
//        } catch (Exception e) {
//            System.out.println("发送GET请求出现异常！" + e);
//            e.printStackTrace();
//        }
//        // 使用finally块来关闭输入流
//        finally {
//            try {
//                if (in != null) {
//                    in.close();
//                }
//            } catch (Exception e2) {
//                e2.printStackTrace();
//            }
//        }
//        return result;
//    }
//
//    public static void main(String[] args) throws Exception {
//
//        String s = HttpClientUtil.doRequest("http://www.baidu.com", null, false);
//        System.out.println(s);
//    }
//}
